# -*- coding: utf-8 -*-
#------------------------------------------------------------
# tvalacarta - XBMC Plugin
# Canal para Extremadura TV
# http://blog.tvalacarta.info/plugin-xbmc/tvalacarta/
#------------------------------------------------------------
import urlparse,re
import urllib

from core import logger
from core import scrapertools
from core.item import Item

DEBUG = True
CHANNELNAME = "extremaduratv"

def isGeneric():
    return True

def mainlist(item):
    logger.info("extremaduratv.mainlist")

    itemlist = []
#    itemlist.append( Item(channel=CHANNELNAME, title="Informativos"   , action="programas"    , url="http://www.canalextremadura.es/alacarta/tv/programas/informativos", category="informativos") )
    itemlist.append( Item(channel=CHANNELNAME, title="Programas"      , action="programas"    , url="http://www.canalextremadura.es/tv/programas", category="programas") )
#    itemlist.append( Item(channel=CHANNELNAME, title="Deportes"       , action="programas"    , url="http://www.canalextremadura.es/alacarta/tv/programas/deportes", category="deportes") )
 #   itemlist.append( Item(channel=CHANNELNAME, title="Archivo"        , action="archivo"      , url="http://www.canalextremadura.es/alacarta/tv/programas/archivo", category="programas") )
    itemlist.append( Item(channel=CHANNELNAME, title="ExtremaduraTV SAT en directo"        , action="play"      , url="http://hlstv.canalextremadura.es/livetv/smil:multistream.smil/playlist.m3u8?DVR", category="programas") )

    return itemlist

def programas(item):
    logger.info("extremaduratv.programas")
    itemlist = []

    # Descarga la página
    data = scrapertools.cachePage(item.url)
    patron  = '<div[^<]+'
    patron += '<div[^<]+'
    patron += '<div[^<]+'
    patron += '<a href="([^"]+)"[^<]+<img class="[^"]+" src="([^"]+)"[^<]+'
    patron += '<div[^<]+'
    patron += '<div[^<]+'
    patron += '<h4[^>]+>([^<]+)'

    matches = re.findall(patron,data,re.DOTALL)

    for url,thumbnail,titulo in matches:
        scrapedtitle = titulo
        scrapedurl = urlparse.urljoin(item.url,url)
        scrapedthumbnail = urlparse.urljoin(item.url,thumbnail)
        scrapedplot = ""
        if (DEBUG): logger.info("title=["+scrapedtitle+"], url=["+scrapedurl+"], thumbnail=["+scrapedthumbnail+"]")

        itemlist.append( Item(channel=CHANNELNAME, title=scrapedtitle , action="episodios" , url=scrapedurl, thumbnail=scrapedthumbnail, show=scrapedtitle) )

    return itemlist

def archivo(item):
    logger.info("extremaduratv.archivo")
    itemlist = []

    # Descarga la página
    '''
    <div class="views-field views-field-field-programa-a-la-carta col-xs-7">
    <div class="field-content">
    <a href="/alacarta/tv/programas/programas/1027/castillos-de-extremadura" title="Título del enlace">
    <div class="field-content">
    <a href="/tv/programas/castillos-de-extremadura">
    <img src="http://www.canalextremadura.es/sites/default/files/styles/alacarta_categorias_programas_archivo/public/foto_cabecera.jpg?itok=OMC1fjc4" width="75" height="46" alt="Ver ficha del programa" title="Ver ficha del programa" />
    </a></div></a>        </div>
    </div>
    <div class="views-field views-field-title col-xs-17">
    <div class="field-content">
    <a href="/alacarta/tv/programas/programas/1027/castillos-de-extremadura" title="Título del enlace">Castillos de Extremadura</a>        </div>
    '''
    data = scrapertools.cachePage(item.url)
    patron  = '<div class="views-field views-field-field-programa-a-la-carta[^<]+'
    patron += '<div class="field-content"[^<]+'
    patron += '<a href="([^"]+)"[^<]+'
    patron += '<div class="field-content"[^<]+'
    patron += '<a[^<]+'
    patron += '<img src="([^"]+)"[^<]+'
    patron += '</a></div></a[^<]+</div[^<]+'
    patron += '</div[^<]+'
    patron += '<div class="views-field views-field-title[^<]+'
    patron += '<div class="field-content"[^<]+'
    patron += '<a[^>]+>([^<]+)</a>'

    matches = re.findall(patron,data,re.DOTALL)

    for url,thumbnail,titulo in matches:
        scrapedtitle = titulo
        scrapedurl = urlparse.urljoin(item.url,url)
        scrapedthumbnail = urlparse.urljoin(item.url,thumbnail)
        scrapedplot = ""
        if (DEBUG): logger.info("title=["+scrapedtitle+"], url=["+scrapedurl+"], thumbnail=["+scrapedthumbnail+"]")

        itemlist.append( Item(channel=CHANNELNAME, title=scrapedtitle , action="episodios" , url=scrapedurl, thumbnail=scrapedthumbnail, show=scrapedtitle) )

    return itemlist

def episodios(item):
    logger.info("extremaduratv.episodios")
    itemlist = []

    '''
<div class="modal-video-ajax modal-video modal fade color-tv" id="modalTV2_172195" tabindex="-1" role="dialog" aria-labelledby="modalTV2_172195Label" aria-hidden="true"
  data-video-imagen-modal="http://www.canalextremadura.es/sites/default/files/styles/nuevo_dise_o_-_grande/public/imagenes-nuevo-disenio/tv-a-la-carta/canalextremadura-01035.jpg?itok=KpF5iTtR"
  data-video-url="/alacarta/tv/videos/en-su-punto-con-granero-ensalada-de-garbanzos-con-zorongollo-010217"
  data-video-titulo-modal="En su punto con Granero: Ensalada de garbanzos con zorongollo (01/02/17)"
  data-video-id-nodo="172195"
  data-video-video-modal="http://tvprogressive.canalextremadura.es/tv/PROG00166537.mp4"
  data-video-aspect-ratio="16:9"
>
    '''


    # Descarga la página
    data = scrapertools.cachePage(item.url)

    #patron  = '<div class="[^"]+" id[^"]+" tabindex[^"]+" role[^"]+" aria-hidden"[^d]+"'
    #patron += 'data[^"]+"[^"]+[^d]+'
    #patron += 'data[^"]+"[^"]+[^d]+'
    patron = 'data-video-imagen-modal="([^"]+)"[^d]+'
    patron += 'data[^"]+"[^"]+[^d]+'
    patron += 'data-video-titulo-modal="([^"]+)"[^d]+'
    patron += 'data[^"]+"[^"]+[^d]+'
    patron += 'data-video-video-modal="([^"]+)"'

    matches = re.findall(patron,data,re.DOTALL)

    for imagen,titulo,url in matches:
        scrapedtitle = titulo.strip()
        scrapedurl = urlparse.urljoin(item.url,url)
        scrapedthumbnail = imagen
        scrapedplot = ""

        # Trata de sacar la fecha de emisión del título
        aired_date = scrapertools.parse_date(scrapedtitle)

        if (DEBUG): logger.info("title=["+scrapedtitle+"], url=["+scrapedurl+"], thumbnail=["+scrapedthumbnail+"]")

        itemlist.append( Item(channel=CHANNELNAME, title=scrapedtitle , action="play" , server="extremaduratv" , url=scrapedurl, thumbnail = scrapedthumbnail, show=item.show, aired_date=aired_date, folder=False) )

    #<li class="pager-next last"><a href="/alacarta/tv/programas/informativos/97/extremadura-noticias-1?page=1" 
    patron = '<li class="pager-next[^<]+<a title="[^"]+" href="([^"]+)"'
    matches = re.findall(patron,data,re.DOTALL)

    for url in matches:
        scrapedurl = urlparse.urljoin(item.url,url)
        itemlist.append( Item(channel=CHANNELNAME, title=">> Página siguiente" , action="episodios" , url=scrapedurl, show=item.show, extra=item.extra) )

    return itemlist

def play(item):

    item.server="extremaduratv";
    itemlist = [item]

    return itemlist

# Verificación automática de canales: Esta función debe devolver "True" si todo está ok en el canal.
def test():
    
    # Todas las opciones tienen que tener algo
    items = mainlist(Item())
    for item in items:
        exec "itemlist="+item.action+"(item)"
    
        if len(itemlist)==0:
            print "La categoria '"+item.title+"' no devuelve programas"
            return False

    # El primer programa de la primera categoria tiene que tener videos
    mainlist_items = mainlist(Item())
    programas_items = programas(mainlist_items[0])
    submenu_episodios_items = episodios(programas_items[0])

    exec "episodios_itemlist="+submenu_episodios_items[0].action+"(submenu_episodios_items[0])"
    if len(episodios_itemlist)==0:
        print "El programa '"+programas_mainlist[0].title+"' no tiene videos en su seccion '"+submenu_episodios_items[0].title+"'"
        return False

    return True
